LanguageSatcomView = require './language-satcom-view'
{CompositeDisposable} = require 'atom'

module.exports = LanguageSatcom =
  languageSatcomView: null
  modalPanel: null
  subscriptions: null

  activate: (state) ->
    @languageSatcomView = new LanguageSatcomView(state.languageSatcomViewState)
    @modalPanel = atom.workspace.addModalPanel(item: @languageSatcomView.getElement(), visible: false)

    # Events subscribed to in atom's system can be easily cleaned up with a CompositeDisposable
    @subscriptions = new CompositeDisposable

    # Register command that toggles this view
    @subscriptions.add atom.commands.add 'atom-workspace', 'language-satcom:toggle': => @toggle()

  deactivate: ->
    @modalPanel.destroy()
    @subscriptions.dispose()
    @languageSatcomView.destroy()

  serialize: ->
    languageSatcomViewState: @languageSatcomView.serialize()

  toggle: ->
    console.log 'LanguageSatcom was toggled!'

    if @modalPanel.isVisible()
      @modalPanel.hide()
    else
      @modalPanel.show()
